ATA Block Driver support for IRQ
[helenos.git] / configure.sh
blob03b7379780a0bc60efdb06d6af001921621089a9
1 #!/bin/sh
4 # Copyright (c) 2019 Jiří Zárevúcky
5 # All rights reserved.
7 # Redistribution and use in source and binary forms, with or without
8 # modification, are permitted provided that the following conditions
9 # are met:
11 # - Redistributions of source code must retain the above copyright
12 # notice, this list of conditions and the following disclaimer.
13 # - Redistributions in binary form must reproduce the above copyright
14 # notice, this list of conditions and the following disclaimer in the
15 # documentation and/or other materials provided with the distribution.
16 # - The name of the author may not be used to endorse or promote products
17 # derived from this software without specific prior written permission.
19 # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
20 # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
21 # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
22 # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
23 # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
24 # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
25 # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
26 # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
27 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
28 # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
31 # Find out the path to the script.
32 SOURCE_DIR=`which -- "$0" 2>/dev/null`
33 # Maybe we are running bash.
34 [ -z "$SOURCE_DIR" ] && SOURCE_DIR=`which -- "$BASH_SOURCE"`
35 [ -z "$SOURCE_DIR" ] && exit 1
36 SOURCE_DIR=`dirname -- "$SOURCE_DIR"`
37 SOURCE_DIR=`cd $SOURCE_DIR && echo $PWD`
39 CONFIG_RULES="${SOURCE_DIR}/HelenOS.config"
40 CONFIG_DEFAULTS="${SOURCE_DIR}/defaults"
42 test "$#" -eq 1 && { test "$1" = "-h" || test "$1" = "--help"; }
43 want_help="$?"
45 if [ "$#" -gt 1 ] || [ "$want_help" -eq 0 ]; then
47 # Find all the leaf subdirectories in the defaults directory.
48 PROFILES=`find ${CONFIG_DEFAULTS} -type d -links 2 -printf "%P\n" | sort`
50 echo "Configures the current working directory as a HelenOS build directory."
51 echo "In-tree build is not supported, you must create a separate directory for build."
52 echo
53 echo "Usage:"
54 echo " $0 -h|--help"
55 echo " $0 [PROFILE]"
56 echo
57 echo "If profile is not specified, a graphical configuration utility is launched."
58 echo
59 echo "Possible profiles:"
60 printf "\t%s\n" $PROFILES
61 echo
63 exit "$want_help"
66 if [ "$PWD" = "$SOURCE_DIR" ]; then
67 echo "We don't support in-tree build."
68 echo "Please create a build directory, cd into it, and run this script from there."
69 echo "Or run \`$0 --help\` to see usage."
70 exit 1
73 ninja_help() {
74 echo 'Run `ninja config` to adjust configuration.'
75 echo 'Run `ninja` to build all program and library binaries, but not bootable image.'
76 echo 'Run `ninja image_path` to build boot image. The file image_path will contain path to the boot image file.'
79 if [ -f build.ninja ]; then
80 echo "This build directory was already configured."
81 echo
82 ninja_help
83 exit 0
86 if ! which meson >/dev/null 2>/dev/null; then
87 echo "Your system does not have Meson installed."
88 echo 'Please use `pip3 install meson`'
89 exit 1
92 if ! which ninja >/dev/null 2>/dev/null; then
93 echo "Your system does not have ninja installed."
94 echo 'Please use `pip3 install ninja`'
95 exit 1
98 # Link tools directory for convenience.
99 if [ ! -e tools ]; then
100 ln -s "${SOURCE_DIR}/tools" tools
103 # Run HelenOS config tool.
104 if [ "$#" -eq 1 ]; then
105 "${SOURCE_DIR}/tools/config.py" "${CONFIG_RULES}" "${CONFIG_DEFAULTS}" hands-off "$1" || exit 1
106 else
107 "${SOURCE_DIR}/tools/config.py" "${CONFIG_RULES}" "${CONFIG_DEFAULTS}" || exit 1
110 PLATFORM=`sed -n '/^PLATFORM\b/p' Makefile.config | sed 's:[^=]*= ::'`
111 MACHINE=`sed -n '/^MACHINE\b/p' Makefile.config | sed 's:[^=]*= ::'`
113 cross_target="$PLATFORM"
114 if [ "$PLATFORM" = 'abs32le' ]; then
115 cross_target='ia32'
117 if [ "$MACHINE" = 'bmalta' ]; then
118 cross_target='mips32eb'
121 cross_def="${SOURCE_DIR}/meson/cross/${cross_target}"
122 cc_arch=`sed -n "s:cc_arch = '\(.*\)':\1:p" "$cross_def"`
124 compname="$cc_arch-helenos-gcc"
125 unset compprefix
127 if which "$compname" >/dev/null 2>/dev/null; then
128 # Compiler is in PATH
129 compprefix="$cc_arch-helenos-"
131 elif [ -n "$CROSS_PREFIX" ]; then
132 if which "$CROSS_PREFIX/bin/$compname" >/dev/null 2>/dev/null; then
133 compprefix="$CROSS_PREFIX/bin/$cc_arch-helenos-"
136 if [ -z "$compprefix" ]; then
137 echo "ERROR: \$CROSS_PREFIX defined but $compname is not present in $CROSS_PREFIX/bin."
138 echo "Run tools/toolchain.sh to build cross-compiling toolchain."
139 exit 1
141 else
142 if [ -z "$XDG_DATA_HOME" ]; then
143 XDG_DATA_HOME="$HOME/.local/share"
146 if which "$XDG_DATA_HOME/HelenOS/cross/bin/$compname" >/dev/null 2>/dev/null; then
147 compprefix="$XDG_DATA_HOME/HelenOS/cross/bin/$cc_arch-helenos-"
148 elif which "/opt/HelenOS/cross/bin/$compname" >/dev/null 2>/dev/null; then
149 compprefix="/opt/HelenOS/cross/bin/$cc_arch-helenos-"
150 elif which "/usr/local/cross/bin/$compname" >/dev/null 2>/dev/null; then
151 compprefix="/usr/local/cross/bin/$cc_arch-helenos-"
154 if [ -z "$compprefix" ]; then
155 echo "ERROR: \$CROSS_PREFIX is not defined and $compname is not present in any of the following standard locations."
156 echo " * $XDG_DATA_HOME/HelenOS/cross/bin"
157 echo " * /opt/HelenOS/cross/bin"
158 echo " * /usr/local/cross/bin"
159 echo "Run tools/toolchain.sh to build cross-compiling toolchain."
160 exit 1
164 sed "s:@COMPPREFIX@:$compprefix:g" "$cross_def" > crossfile || exit 1
166 meson setup "${SOURCE_DIR}" '.' --cross-file crossfile || exit 1
168 echo
169 echo "Configuration for platform $PLATFORM finished."
170 echo
171 ninja_help